# -*- coding: koi8-r -*-
## OJAB database generation module
## Copyright (C) Alexey Frolov <falexey@nm.ru>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

import string,gzip,speak,ojab_config

lofs=ojab_config.lofs
lpom=ojab_config.lpom
speak.lpo=ojab_config.lpo

def analyzer(a):
    # koi8-r
    abcr='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    abc='abcdefghijklmnopqrstuvwxyzţ.,'
    labc=len(abc)
    ld=2
    ws=[]
    pot=[]
    cpot=0
    w=''
    cws=0
    wsd,potd=[],[]
    for i in xrange(labc*(labc+1)):
	wsd.append([])
	potd.append([])
    a=' , '.join(string.split(' . '.join(string.split(''.join(string.split(a,'-'+chr(0))),'.')),','))
    for c in a:
	if c in abcr: c=abc[abcr.index(c)]
	if c in abc: w+=c
	else:
	    if w!='':
		nc=abc.index(w[0])
		if len(w)>1:
		    nc+=(abc.index(w[1])+1)*labc
		    we=w[2:]
		else: we=w
	        if not we in wsd[nc]:
		    wsd[nc].append(we)
		    potd[nc].append(cws)
		    ws.append(w)
		    pot.append(cws)
		    cws+=1
		    if cws==65535: break
		else: pot.append(potd[nc][wsd[nc].index(we)])
		w=''

    cpos=[]
    cpo=[]
    po=[]
    speak.addpo(lofs,cpos,cpo,po,cws)
    speak.adddb(lofs,cpos,cpo,po,pot)
    for n in xrange(cws):
	for o in xrange(lofs):
	    if cpos[n][o]>lpom: cpos[n][o]=lpom
    return ws,cpos,cpo,po

def c2(i):
    a=divmod(i,256)
    return chr(a[1])+chr(a[0])

def savedb():
    ws,cpos,cpo,po=analyzer(open('./db.txt').read())
    open('./words.koi8-r.db','w').write(chr(0).join(ws))
    ga=[c2(lofs)]
    for n in xrange(len(ws)):
	a=''
	for o in xrange(lofs):
	    a+=c2(cpos[n][o])
	    for i in xrange(cpos[n][o]):
		a+=c2(cpo[n][o][i])+c2(po[n][o][i])
	ga.append(a)
    gzip.open('./wordspo.db','w').write(''.join(ga))
    print len(ws),'words'

savedb()
